function filter_set_callbacks(filter)
{
    filter.after_load = function() {filter.AfterLoad();};
    filter.dates.attachEvent("onSelect", function(id) {filter.OnSelect(id);});
}

function FILTER(id, control)
{
    //this.last_selected = 0;
    
    this.dates = new dhtmlXTreeObject(id, "100%", "100%", 0);
    this.dates.enableTreeLines(true);
    if (adei.cfg.dhtmlx_iconset) {
        this.dates.setImagePath(adei.cfg.dhtmlx_iconset);
    }
    this.dates.setDataMode("xml");

    this.search = "";
    this.parameters = "";
    this.last_parameters = "";
    this.window = "";

    filter_set_callbacks(this);

    this.Update();
}

FILTER.prototype.HasSearch = function()
{
    return this.search != "" && this.search != undefined;
}

FILTER.prototype.OnSelect = function(id)
{
    //if (!this.HasSearch()) {
    //    this.last_selected = id;
    //}
    var props = "kdb_run=&kdb_date=" + id + "&kdb_search=" + this.search + "&kdb_parameters=" + this.parameters + "&kdb_window=" + this.window + "&kdb_page=1";
    adei.SetCustomProperties(props);
}

FILTER.prototype.AfterLoad = function()
{
    if (this.HasSearch()) {
        this.dates.selectItem("all", true, false);
    }
    else {
        //this.dates.selectItem(this.last_selected, true, false);
        // Year
        var index = this.dates.hasChildren("all") - 1;
        if (index != -1) {
            var id = this.dates.getItemIdByIndex("all", index);
            this.dates.openItem(id);
            // Month
            index = this.dates.hasChildren(id) - 1;
            id = this.dates.getItemIdByIndex(id, index);
            this.dates.openItem(id);
            // Day
            index = this.dates.hasChildren(id) - 1;
            id = this.dates.getItemIdByIndex(id, index);
            this.dates.selectItem(id, true, false);
        }
    }
}

FILTER.prototype.SetSearch = function(search, parameters, window)
{
    var input = document.getElementById("parameters");
    this.parameters = parameters;
    var value = parameters;
    input.value = decodeURIComponent(value);
    
    if (search == this.search && parameters == this.last_parameters && window == this.window) {
        var selected = this.dates.getSelectedItemId();
        var props = "kdb_date=" + selected + "&kdb_search=" + search + "&kdb_parameters=" + this.parameters + "&kdb_window=" + this.window;
        katrin.SetCustomProperties(props);
        return;
    }

    this.search = search;
    this.last_parameters = parameters;
    this.window = window;

    this.Update();
}

FILTER.prototype.Update = function()
{
    this.dates.deleteChildItems(0);
    var props = "target=dates&kdb_search=" + this.search + "&kdb_parameters=" + this.last_parameters + "&kdb_window=" + this.window;
    this.dates.loadXML(adei.GetURL("setups/katrin/services/katrin.fcgi", props), this.after_load);
}

FILTER.prototype.SetParameters = function(parameters)
{
}

FILTER.prototype.ApplyParameters = function()
{
    var input = document.getElementById("parameters");
    this.parameters = encodeURIComponent(input.value);
    katrin.SetCustomProperties("kdb_date=&kdb_run=&kdb_parameters=" + this.parameters);
}

FILTER.prototype.FocusParameters = function()
{
    var input = document.getElementById("parameters");
    
    if (input.value == "help") {
        input.value = "";
    }
    
    adei.OpenControl("filter");
    input.focus();
    input.select();
}

FILTER.prototype.ClearParameters = function()
{
    var input = document.getElementById("parameters");
    input.value = "";
    this.ApplyParameters();
}

