<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output encoding="utf-8"/>

<xsl:variable name="service">
    services/katrin.php?target=file&amp;
</xsl:variable>

<xsl:template name="image">
    <xsl:param name="width" />
    <xsl:param name="height" />

    <xsl:variable name="link">
        <xsl:text>services/katrin.php?target=file&amp;</xsl:text>
        <xsl:if test="@run">
            <xsl:text>kdb_run=</xsl:text>
            <xsl:value-of select="@run" />
            <xsl:text>&amp;</xsl:text>
        </xsl:if>
        <xsl:text>kdb_name=</xsl:text>
        <xsl:value-of select="@name" />
    </xsl:variable>

    <xsl:element name="a">
        <xsl:attribute name="href">
            <xsl:value-of select="$link" />
            <xsl:text>.png</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="target">_blank</xsl:attribute>
        <xsl:element name="img">
            <xsl:attribute name="src">
                <xsl:value-of select="$link" />
                <xsl:text>_pv.png</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="border">0</xsl:attribute>
            <xsl:attribute name="alt">
                <xsl:value-of select="." />
            </xsl:attribute>
            <xsl:attribute name="width">
                <xsl:value-of select="$width" />
            </xsl:attribute>
            <xsl:attribute name="height">
                <xsl:value-of select="$height" />
            </xsl:attribute>
        </xsl:element>
    </xsl:element>

</xsl:template>

<xsl:template match="image" mode="small">
    <xsl:call-template name="image">
        <xsl:with-param name="width" select="'150'" />
        <xsl:with-param name="height" select="'100'" />
    </xsl:call-template>
</xsl:template>

<xsl:template match="image" mode="normal">
    <xsl:call-template name="image">
        <xsl:with-param name="width" select="'300'" />
        <xsl:with-param name="height" select="'200'" />
    </xsl:call-template>
</xsl:template>

<xsl:template match="image" mode="large">
    <xsl:call-template name="image">
        <xsl:with-param name="width" select="'600'" />
        <xsl:with-param name="height" select="'400'" />
    </xsl:call-template>
</xsl:template>

<xsl:template match="image" mode="table">
    <td>
        <xsl:apply-templates select="." mode="small" />
    </td>
</xsl:template>

<xsl:template match="image" mode="title">
    <th><xsl:value-of select="." /></th>
</xsl:template>

<xsl:template match="file">
    <p style="margin: 0">
        <xsl:element name="a">
            <xsl:attribute name="href">
                <xsl:text>services/katrin.php?target=file</xsl:text>
                <xsl:text>&amp;kdb_download=yes</xsl:text>
                <xsl:if test="@run">
                    <xsl:text>&amp;kdb_run=</xsl:text>
                    <xsl:value-of select="@run" />
                </xsl:if>
                <xsl:if test="@name">
                    <xsl:text>&amp;kdb_name=</xsl:text>
                    <xsl:value-of select="@name" />
                </xsl:if>
            </xsl:attribute>
            <xsl:value-of select="." />
        </xsl:element>
        <xsl:if test="@filesize">
            <span style="font-size: small">
                <xsl:text> (</xsl:text>
                <xsl:value-of select="@filesize" />
                <xsl:text>)</xsl:text>
            </span>
        </xsl:if>
    </p>
</xsl:template>

<!-- ADEI links and images -->
<xsl:template name="adeiurl">
    <xsl:text>db_server=</xsl:text>
    <xsl:value-of select="@server" />
    <xsl:text>&amp;db_name=</xsl:text>
    <xsl:value-of select="@database" />
    <xsl:text>&amp;db_group=</xsl:text>
    <xsl:value-of select="@group" />
    <xsl:if test="@mask">
        <xsl:text>&amp;db_mask=</xsl:text>
        <xsl:value-of select="@mask" />
    </xsl:if>
    <xsl:if test="@window">
        <xsl:text>&amp;window=</xsl:text>
        <xsl:value-of select="@window" />
    </xsl:if>
</xsl:template>

<xsl:template match="adei">
    <xsl:element name="a">
        <xsl:attribute name="href">
            <xsl:text>javascript:adei.config.Load('</xsl:text>
            <xsl:call-template name="adeiurl" />
            <xsl:text>&amp;module=graph&amp;setup=katrin, true)</xsl:text>
        </xsl:attribute>
        <xsl:value-of select="." />
    </xsl:element>
</xsl:template>

<!--<xsl:template match="adeiimage" mode="image">
    <xsl:variable name="url">
        <xsl:apply-templates select="adei" />
    </xsl:variable>
    <td>
        <xsl:element name="a">
            <xsl:attribute name="href">
                <xsl:text>javascript:adei.config.Load('</xsl:text>
                <xsl:value-of select="$url" />
                <xsl:text>&amp;module=graph&amp;setup=katrin', true)</xsl:text>
            </xsl:attribute>
            <xsl:element name="img">
                <xsl:attribute name="src">
                    <xsl:text>services/getimage.php?</xsl:text>
                    <xsl:value-of select="$url" />
                    <xsl:text>&amp;hide_axes=1&amp;precision=LOW&amp;width=</xsl:text>
                    <xsl:value-of select="@width" />
                    <xsl:text>&amp;height=</xsl:text>
                    <xsl:value-of select="@height" />
                </xsl:attribute>
                <xsl:attribute name="alt">
                    <xsl:value-of select="@text" />
                </xsl:attribute>
                <xsl:attribute name="width">
                    <xsl:value-of select="@width" />
                </xsl:attribute>
                <xsl:attribute name="height">
                    <xsl:value-of select="@height" />
                </xsl:attribute>
                <xsl:attribute name="border">
                    <xsl:text>0</xsl:text>
                </xsl:attribute>
            </xsl:element>
        </xsl:element>
    </td>
</xsl:template>

<xsl:template match="adeiimage" mode="title">
    <th><xsl:value-of select="@text" /></th>
</xsl:template>-->

<xsl:template match="plots">
    <table style="margin:10px 0">
        <tr>
            <xsl:apply-templates select="image" mode="title" />
        </tr>
        <tr>
            <xsl:apply-templates select="image" mode="table" />
        </tr>
    </table>
</xsl:template>

<xsl:template match="streams">
    <xsl:for-each select="type">
        <xsl:variable name="title">
            <xsl:choose>
                <xsl:when test="@name=uw">UW</xsl:when>
                <xsl:when test="@name='ipe3_energy'">IPE3 Energy</xsl:when>
                <xsl:when test="@name='ipe3_waveform'">IPE3 Waveform</xsl:when>
                <xsl:when test="@name='ipe3_histogram'">IPE3 Histogram</xsl:when>
                <xsl:when test="@name='ipe4_energy'">IPE4 Energy</xsl:when>
                <xsl:when test="@name='ipe4_waveform'">IPE4 Waveform</xsl:when>
                <xsl:when test="@name='ipe4_histogram'">IPE4 Histogram</xsl:when>
            </xsl:choose>
        </xsl:variable>
        <xsl:element name="img">
            <xsl:attribute name="src">
                <xsl:text>setups/katrin/images/</xsl:text>
                <xsl:value-of select="@name" />
                <xsl:text>.png</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="height">16</xsl:attribute>
            <xsl:attribute name="alt">
                <xsl:value-of select="$title" />
            </xsl:attribute>
            <xsl:attribute name="title">
                <xsl:value-of select="$title" />
            </xsl:attribute>
            <xsl:attribute name="style">
                <xsl:text>margin: 0 5px; vertical-align: middle</xsl:text>
            </xsl:attribute>
        </xsl:element>
    </xsl:for-each>
</xsl:template>

<xsl:template match="downloads">
    <h4>Downloads</h4>
    <xsl:apply-templates select="file" />
</xsl:template>

<xsl:template match="parameters">
    <xsl:if test="magnet_west or magnet_east">
        <div style="background-color:#ccffcc">
            <xsl:if test="magnet_west">
                West magnet:
                <b><xsl:value-of select="magnet_west" />A (<xsl:value-of select="field_west" />T)</b>
            </xsl:if>
            <xsl:if test="magnet_east">
                East magnet:
                <b><xsl:value-of select="magnet_east" />A (<xsl:value-of select="field_east" />T)</b>
            </xsl:if>
        </div>
    </xsl:if>
    <xsl:if test="det_ps or ps_egun">
        <div>
            <xsl:if test="det_ps">
                Valve Det/PS:
                <b>
                    <xsl:value-of select="det_ps" />
                    <xsl:text> </xsl:text>
                </b>
            </xsl:if>
            <xsl:if test="ps_egun">
                Valve PS/egun:
                <b>
                    <xsl:value-of select="ps_egun" />
                    <xsl:text> </xsl:text>
                </b>
            </xsl:if>
        </div>
    </xsl:if>
    <xsl:if test="t or s1 or s2 or s3 or s4 or d1 or d2">
        <div style="background-color:#ffcc99">
            <xsl:if test="t">
                T:
                <b>
                    <xsl:value-of select="t" />
                    <xsl:text> </xsl:text>
                </b>
            </xsl:if>
            <xsl:if test="s1">
                S1:
                <b>
                    <xsl:value-of select="s1" />
                    <xsl:text> </xsl:text>
                </b>
            </xsl:if>
            <xsl:if test="s2">
                S2:
                <b>
                    <xsl:value-of select="s2" />
                    <xsl:text> </xsl:text>
                </b>
            </xsl:if>
            <xsl:if test="s3">
                S3:
                <b>
                    <xsl:value-of select="s3" />
                    <xsl:text> </xsl:text>
                </b>
            </xsl:if>
            <xsl:if test="s4">
                S4:
                <b>
                    <xsl:value-of select="s4" />
                    <xsl:text> </xsl:text>
                </b>
            </xsl:if>
            <xsl:if test="d1">
                D1:
                <b>
                    <xsl:value-of select="d1" />
                    <xsl:text> </xsl:text>
                </b>
            </xsl:if>
            <xsl:if test="d2">
                D2:
                <b>
                    <xsl:value-of select="d2" />
                    <xsl:text> </xsl:text>
                </b>
            </xsl:if>
        </div>
    </xsl:if>
    <xsl:if test="fug1 or fug2 or fug3 or fug4 or fug5">
        <div style="background-color:#ffcc99">
            <xsl:if test="fug1">
                FUG1:
                <b><xsl:value-of select="fug1" />kV </b>
            </xsl:if>
            <xsl:if test="fug2">
                FUG2:
                <b><xsl:value-of select="fug2" />kV </b>
            </xsl:if>
            <xsl:if test="fug3">
                FUG3:
                <b><xsl:value-of select="fug3" />kV </b>
            </xsl:if>
            <xsl:if test="fug4">
                FUG4:
                <b><xsl:value-of select="fug4" />kV </b>
            </xsl:if>
            <xsl:if test="fug5">
                FUG5:
                <b><xsl:value-of select="fug5" />kV </b>
            </xsl:if>
        </div>
    </xsl:if>
    <xsl:if test="pressure">
        <div style="background-color:#ffcc99">
            Pressure:
            <b><xsl:value-of select="pressure" />mbar </b>
        </div>
    </xsl:if>
    <xsl:if test="egun_uv or egun_shutter or egun_hv or egun_x or egun_y">
        <div style="background-color:#99ccff">
            <xsl:if test="egun_uv">
                UV light:
                <b>
                    <xsl:value-of select="egun_uv" />
                    <xsl:text> </xsl:text>
                </b>
            </xsl:if>
            <xsl:if test="egun_shutter">
                Shutter:
                <b>
                    <xsl:value-of select="egun_shutter" />
                    <xsl:text> </xsl:text>
                </b>
            </xsl:if>
            <xsl:if test="egun_hv">
                Voltage:
                <b><xsl:value-of select="egun_hv" />kV </b>
            </xsl:if>
            <xsl:if test="egun_x">
                X:
                <b><xsl:value-of select="egun_x" />° </b>
            </xsl:if>
            <xsl:if test="egun_y">
                Y:
                <b><xsl:value-of select="egun_y" />° </b>
            </xsl:if>
        </div>
    </xsl:if>
</xsl:template>

<xsl:template match="transmission">
    <div>
        <h4>
	    <xsl:text>Transmission (</xsl:text>
	    <xsl:value-of select="@parameter" />
	    <xsl:text>):</xsl:text>
        </h4>
        <xsl:apply-templates select="image" mode="large" />
    </div>
</xsl:template>

<xsl:template match="parameter">
    <div>
        <h4>
	    <xsl:text>Control parameter (</xsl:text>
	    <xsl:value-of select="@parameter" />
	    <xsl:text>):</xsl:text>
	</h4>
        <xsl:apply-templates select="image" mode="normal" />
    </div>
</xsl:template>

<xsl:template match="countrate">
    <div>
        <h4>Eventrate:</h4>
        <xsl:apply-templates select="image" mode="normal" />
    </div>
</xsl:template>

<xsl:template match="errors">
    <tr>
        <td colspan="2">
            <p class="errors">
                <xsl:for-each select="error">
                    <span class="service">
                        <xsl:value-of select="@service" />
                    </span>
                    <xsl:text>: </xsl:text>
                    <xsl:value-of select="." />
                    <br />
                </xsl:for-each>
            </p>
        </td>
    </tr>
</xsl:template>

<xsl:template match="run">
    <table>
        <tr>
            <td>
                <h2>Run <xsl:value-of select="identifier" /></h2>
            </td>
            <td>
                <a href="javascript:katrin.SetCustomProperties('kdb_run=')">
                    Back to run overview
                </a>
            </td>
        </tr>
        <tr>
            <td colspan="2" style="padding: 0 10px">
                <xsl:apply-templates select="streams" />
            </td>
        </tr>
        <xsl:apply-templates select="errors" />
        <tr>
            <td rowspan="2" style="width:600px; padding: 0 10px 0 0">
                <xsl:apply-templates select="plots/transmission" />
                <div class="properties">
                    <div style="background-color:silver">
                        Date:
                        <b>
                            <xsl:value-of select="date" />
                            <xsl:text> </xsl:text>
                        </b>
                        Timestamp:
                        <b><xsl:value-of select="start" /> - <xsl:value-of select="end" /></b>
                    </div>
                    <div style="background-color:#ffff99">
                        Detector:
                        <b>
                            <xsl:value-of select="detector" />
                            <xsl:text> </xsl:text>
                        </b>
                        X:
                        <b><xsl:value-of select="detector_x" />cm </b>
                        Y:
                        <b><xsl:value-of select="detector_y" />cm </b>
                        Z:
                        <b><xsl:value-of select="detector_z" />cm </b>
                    </div>
                    <div style="background-color:#ffff99">
                        Configuration:
                        <b>
                            <xsl:value-of select="configuration" />
                            <xsl:text> </xsl:text>
                        </b>
                        ORCA version:
                        <b><xsl:value-of select="orca_version" /> </b>
                    </div>
                    <xsl:apply-templates select="parameters" />
                    <div style="background-color:black; color:white">
                        Comment:
                    </div>
                    <div style="background-color:black; color:white">
                        <b><xsl:value-of select="comment" /></b>
                    </div>
                </div>
            </td>
            <td>
                <xsl:apply-templates select="plots/countrate" />
                <xsl:apply-templates select="plots/parameter" />
                <xsl:apply-templates select="downloads" />
            </td>
        </tr>
        <tr>
            <td style="vertical-align:bottom">
                <div>
                    <xsl:if test="../subruns">
                        <a href="javascript:katrin.SetCustomProperties('kdb_subruns=0')">
                            Hide subruns
                        </a>
                    </xsl:if>
                    <xsl:if test="not(../subruns)">
                        <a href="javascript:katrin.SetCustomProperties('kdb_subruns=1')">
                            Show subruns
                        </a>
                    </xsl:if>
                </div>
            </td>
        </tr>
    </table>
</xsl:template>

<xsl:template match="subrun">
    <div style="margin: 20px 0">
        <h4>Subrun <xsl:value-of select="identifier" /></h4>
        <div class="properties" style="width:600px">
            <div style="background-color:silver">
                Timestamp:
                <b><xsl:value-of select="start" /> - <xsl:value-of select="end" /></b>
            </div>
            <xsl:apply-templates select="parameters" />
            <div style="background-color:black; color:white">
                Comment:
            </div>
            <div style="background-color:black; color:white">
                <b><xsl:value-of select="comment" /></b>
            </div>
        </div>
        <xsl:apply-templates select="plots" />
    </div>
</xsl:template>

<xsl:template match="subruns">
    <div>
        <xsl:apply-templates select="subrun" />
    </div>
</xsl:template>

<xsl:template match="/result">
    <div style="margin: 10px">
        <xsl:choose>
            <xsl:when test="Error">
                <h2>Error</h2>
                <xsl:value-of select="Error" />
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates select="run" />
                <xsl:apply-templates select="subruns" />
            </xsl:otherwise>
        </xsl:choose>
    </div>
</xsl:template>
</xsl:stylesheet>
